.586p
.model flat,stdcall
option casemap:none

include calc32.inc

.code
start:
	invoke	GetModuleHandle, NULL
	mov	       hInstance, eax
	invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax
; -----------------------------------------------------------------------
DlgProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
        
        mov eax,uMsg
	.if eax == WM_INITDIALOG
		invoke LoadIcon,hInstance,ID_ICON
		invoke SendMessage, hWnd, WM_SETICON, 1, eax
		invoke SetWindowText,hWnd,addr caption
		invoke CheckRadioButton,hWnd,IDC_XOR, IDC_BTS, IDC_XOR
		invoke GetDlgItem,hWnd,IDC_OP2
		mov idc_buffer1,eax
		invoke GetDlgItem,hWnd,IDC_CF
		mov idc_buffer2,eax
		invoke EnableWindow,idc_buffer2,FALSE
		
	.elseif eax == WM_COMMAND
	       mov eax,wParam
	       mov ebx,eax
	       shr ebx,16
		.if ax == BTN_ABOUT
			invoke MessageBox,hWnd,addr AboutTxt,addr caption,MB_ICONINFORMATION
		      
		.elseif ( ( ax == IDC_OP1 || ax == IDC_OP2 ) && bx == EN_CHANGE ) || ( ( ax >= IDC_XOR || ax <=IDC_BTS || ax == IDC_CF ) && bx == BN_CLICKED )  
	       
			invoke GetDlgItemText,hWnd,IDC_OP1,addr szOperand1,sizeof szOperand1
			invoke GetDlgItemText,hWnd,IDC_OP2,addr szOperand2,sizeof szOperand2
			
			invoke HexToDw,addr szOperand1
			mov operand1,eax
			invoke HexToDw,addr szOperand2
			mov operand2,eax
						
			xor esi,esi
			mov edi,IDC_XOR
		_l1:
			invoke GetDlgItem,hWnd,edi
			invoke SendMessage,eax,BM_GETCHECK,0,0
			or eax,eax
			jnz _esc
			inc edi
			inc esi
			cmp esi,n ; number of operators
		jb _l1
		
		_esc:
			mov operand_idc,edi
			invoke GetDlgItemText,hWnd,edi,addr szStatus, sizeof szStatus
			invoke SetDlgItemText,hWnd,IDC_STATUS,addr szStatus
			
			invoke EnableWindow,idc_buffer1,TRUE
			invoke EnableWindow,idc_buffer2,FALSE
			
			mov eax,operand_idc
			sub eax,IDC_XOR
			jmp [Table+eax*4]
			
		      Table \
		       dd case_01,case_02,case_03,case_04,case_05,case_06,case_07,case_08,case_09,case_10,case_11
		       dd case_12,case_13,case_14,case_15,case_16,case_17,case_18,case_19,case_20,case_21,case_22
		       dd case_23,case_24,case_25,case_26,case_27,case_28,case_29,case_30,case_31,case_32
			
		case_01:
			mov eax,operand1
			mov ecx,operand2
			xor eax,ecx
			jmp _endsw
			
		case_02:
			mov eax,operand1
			mov ecx,operand2
			and eax,ecx
			jmp _endsw
			
		case_03:
			mov eax,operand1
			mov ecx,operand2
			or eax,ecx
			jmp _endsw
			
		case_04:
			mov eax,operand1
			mov ecx,operand2
			test eax,ecx
			jmp _endsw
			
		case_05:
			mov eax,operand1
			mov ecx,operand2
			cmp eax,ecx
			jmp _endsw
			
		case_06:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			;mov ecx,operand2
			inc eax
			jmp _endsw
			
		case_07:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			;mov ecx,operand2
			dec eax
			jmp _endsw	
			
		case_08:
			mov eax,operand1
			mov ecx,operand2
			add eax,ecx
			jmp _endsw
			
		case_09:
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc1
			stc
			jmp _next1
			_clc1:
			clc
			_next1:
			mov eax,operand1
			mov ecx,operand2
			adc eax,ecx
			jmp _endsw	
			
		case_10:
			mov eax,operand1
			mov ecx,operand2
			sub eax,ecx
			jmp _endsw
			
		case_11:
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc2
			stc
			jmp _next2
			_clc2:
			clc
			_next2:
			mov eax,operand1
			mov ecx,operand2
			sbb eax,ecx
			jmp _endsw	
			
		case_12:		
			mov eax,operand1
			mov ecx,operand2	
			cmp ecx,0FFh
			ja _InputError
			shl eax,cl
			jmp _endsw
			
		case_13:
			mov eax,operand1
			mov ecx,operand2	
			cmp ecx,0FFh
			ja _InputError
			shr eax,cl
			jmp _endsw
			
		case_14:
			mov eax,operand1
			mov ecx,operand2	
			cmp ecx,0FFh
			ja _InputError
			sal eax,cl
			jmp _endsw
			
		case_15:
			mov eax,operand1
			mov ecx,operand2
			cmp ecx,0FFh
			ja _InputError
			sar eax,cl
			jmp _endsw
			
		case_16:
			mov eax,operand1
			mov ecx,operand2
			cmp ecx,0FFh
			ja _InputError
			rol eax,cl
			jmp _endsw
			
		case_17:
			mov eax,operand1
			mov ecx,operand2
			cmp ecx,0FFh
			ja _InputError
			ror eax,cl
			jmp _endsw
			
		case_18:
			mov ecx,operand2
			cmp ecx,0FFh
			ja _InputError
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc3
			stc
			jmp _next3
			_clc3:
			clc
			_next3:
			mov eax,operand1
			mov ecx,operand2
			rcl eax,cl
			jmp _endsw
			
		case_19:
			mov ecx,operand2
			cmp ecx,0FFh
			ja _InputError
			invoke EnableWindow,idc_buffer2,TRUE
			invoke SendMessage,idc_buffer2,BM_GETCHECK,0,0
			or eax,eax
			jz _clc4
			stc
			jmp _next4
			_clc4:
			clc
			_next4:
			mov eax,operand1
			mov ecx,operand2
			rcr eax,cl
			jmp _endsw
			
		case_20:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			;mov ecx,operand2
			bswap eax
			jmp _endsw
			
		case_21:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			;mov ecx,operand2
			not eax
			jmp _endsw
			
		case_22:
			invoke EnableWindow,idc_buffer1,FALSE
			mov eax,operand1
			;mov ecx,operand2
			neg eax
			jmp _endsw
			
		case_23:
			mov eax,operand1
			mov ecx,operand2
			cdq
			mul ecx
			jmp _endsw
			
		case_24:
			mov eax,operand1
			mov ecx,operand2
			cdq
			imul ecx
			jmp _endsw
			
		case_25:
			mov eax,operand1
			mov ecx,operand2
			or ecx,ecx
			jz _InputError
			cdq
			div ecx
			jmp _endsw
			
		case_26:
			mov eax,operand1
			mov ecx,operand2
			or ecx,ecx
			jz _InputError
			cdq
			idiv ecx
			jmp _endsw
			
		case_27:
			mov eax,operand1
			mov ecx,operand2
			bsf eax,ecx
			jmp _endsw
			
		case_28:
			mov eax,operand1
			mov ecx,operand2
			bsr eax,ecx
			jmp _endsw
			
		case_29:
			mov eax,operand1
			mov ecx,operand2
			bt eax,ecx
			jmp _endsw
			
		case_30:
			mov eax,operand1
			mov ecx,operand2
			btc eax,ecx
			jmp _endsw
			
		case_31:
			mov eax,operand1
			mov ecx,operand2
			btr eax,ecx
			jmp _endsw
			
		case_32:
			mov eax,operand1
			mov ecx,operand2
			bts eax,ecx
			jmp _endsw
			
		_InputError:
			invoke SetDlgItemText,hWnd,IDC_HEXRESULT,chr$("Invalid operands!")
			xor eax,eax
			ret
			
		_endsw:
		
		mov ebx,eax
		push ebx
		mov eax,operand_idc
		cmp eax,IDC_MUL
		jb _ndp
		cmp eax,IDC_IDIV
		ja _ndp
		invoke wsprintf,addr szHexResult,chr$("%08X:%08X"),edx,ebx
		jmp _decp
		_ndp:
		invoke wsprintf,addr szHexResult,chr$("%08X"),ebx
		_decp:
		pop ebx
		
		invoke wsprintf,addr szDecResult,chr$("%d"),ebx
		invoke SetDlgItemText,hWnd,IDC_HEXRESULT,addr szHexResult
		invoke SetDlgItemText,hWnd,IDC_DECRESULT,addr szDecResult
		
		.endif
		
	.elseif eax == WM_CLOSE
		invoke EndDialog,hWnd,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

; by lingo (drizz stdlib)
HexToDw PROC pString:DWORD
	mov ecx,pString
	xor eax,eax
	mov [ebp+8],ebx ;save ebx register
	xor ebx,ebx
@@:	
	movzx edx,byte ptr[ecx]
	shl eax,4
	and ebx,0Fh
	add eax,ebx
	cmp edx,40h
	sbb ebx,ebx
	sub edx,37h
	and ebx,7
	inc ecx
	add ebx,edx
	jns @B
	mov ebx,[ebp+8]
	ret 1*4
HexToDw ENDP

end start
